﻿package com.nosuch {
	import flash.utils.*;
	import flash.events.Event;
	import flash.display.DisplayObject;
	
	public class SpringController {
		private var _prop:String;
		private var _controllerTable:Object;
		private var _springDataTable:Dictionary;
		private var _easingArray:Array;
		private var _dampingArray:Array;
		private var max:uint;
		private var clipCount:uint;

		public function SpringController(prop:String):void {
			// trace("SPRINGCONTROLLER CREATED FOR prop=",prop);
			_prop = prop;
			_controllerTable = new Object();
			_springDataTable = new Dictionary();
			_easingArray = new Array();
			_dampingArray = new Array();
		}
		
		public function startSpringing(springData:SpringData):void {
			var i:uint;
			clipCount = 0;
			max = springData.itemList.length;
			var item:DisplayObject;
			for ( i=0; i<max; i++ ) {
				// item = springData.itemList[i] as DisplayObject;
				item = springData.itemList[i];
				springData.speedTable[item] = 0;
				if (_prop == "scale") {
					if ( springData.startValue == null ) {
						item.scaleX = item.scaleX;
						item.scaleY = item.scaleY;
						springData.goalTable[item] = springData.endValue[i];
					} else {
						item.scaleX = springData.startValue[i];
						item.scaleY = springData.startValue[i];
						springData.goalTable[item] = springData.endValue[i];
					}
				} else {
					if (springData.startValue == null) {
						item[_prop] = item[_prop];
						springData.goalTable[item] = springData.endValue[i];
					} else {
						item[_prop] = springData.startValue[i];
						springData.goalTable[item] = springData.endValue[i];
					}
				}
				if (springData.myEasing is Number) {
					springData.easingTable[item] = springData.myEasing;
					springData.dampingTable[item] = springData.myDamping;
				} else {
					springData.easingTable[item] = springData.myEasing[i];
					springData.dampingTable[item] = springData.myDamping[i];
				}
				_springDataTable[item] = springData;
			}
			springData.index = 0;
			springData.id = setInterval(startNextItem, springData.myInterval, springData);
			_controllerTable[springData.id] = springData;
		}
		private function startNextItem(springData:SpringData):void {
			if ( springData.index < springData.itemList.length ) {
				var item:DisplayObject = springData.itemList[springData.index];
				springData.itemList[springData.index].visible = true;
				springData.itemList[springData.index].addEventListener(Event.ENTER_FRAME, springItem);
				springData.index++;
			} else {
				clearInterval(springData.id);
				delete _controllerTable[springData.id];
			}
		}
		private function springItem(evt:Event):void {
			var item:DisplayObject = evt.target as DisplayObject;
			var springData:SpringData = _springDataTable[item] as SpringData;
			var speed:Number = springData.speedTable[item];
			var goal:Number = springData.goalTable[item];
			var myEasing:Number = springData.easingTable[item];
			var myDamping:Number = springData.dampingTable[item];
			var delta:Number;
			var itemAngle:Number;
			var deltaAngle:Number;
			
			if (_prop == "rotation" ) {
				itemAngle = fixAngle(item.rotation);
				goal = fixAngle(goal);
				deltaAngle = fixAngle(itemAngle + (360-goal));
				if (deltaAngle > 180) {
					delta = 360 - deltaAngle;
				} else {
					delta = deltaAngle * -1;
				}
			} else {
				if (_prop == "scale") {
					delta = goal - item.scaleX;
				} else {
					delta = goal - item[_prop];
				}
			}
			speed = (speed*myDamping) + delta*myEasing;
			if (Math.abs(speed) < springData.minSpeed && Math.abs(delta) < springData.minDelta) {
				if (_prop == "scale" ) {
					item.scaleX = item.scaleY = goal;
				} else {
					item[_prop] = goal;
				}
				item.removeEventListener(Event.ENTER_FRAME, springItem);
				if ( item.alpha <= 0 ) {
					item.visible = false;
				}
				onClipComplete(item, springData);
			} else {
				springData.speedTable[item] = speed;
				if (_prop == "scale") {
					item.scaleX += speed;
					item.scaleY = item.scaleX;
				} else {
					item[_prop] += speed;
				}
			}
		}
		
		private function onClipComplete(item, springData):void {
			++clipCount;
			if (clipCount == max) {
				item.removeEventListener(Event.ENTER_FRAME, springItem);
				if (springData.finishFunction != null) {
					if (springData.finishFunctionData != null) {
						springData.finishFunction(springData.finishFunctionData);
					} else {
						springData.finishFunction();
					}
				}
			}
		}
		
		private function fixAngle(angle:Number):Number {
			if (angle>360) {
				angle = angle % 360;
			}
			while (angle<0) {
				angle += 360;
			}
			return angle;
		}
		
		public function stopSpringing():void {
			var i:uint;
			var id:String;
			var springData:SpringData;
			var maxKill:uint;
			
			for (id in _controllerTable) {
				springData = _controllerTable[id] as SpringData;
				maxKill = springData.itemList.length;
				clearInterval(springData.id);
				for (i=0; i<maxKill; i++) {
					springData.itemList[i].removeEventListener(Event.ENTER_FRAME, springItem);
				}
				delete _controllerTable[id];
			}
		}
	}

}